{"openapi":"3.1.0","info":{"title":"Maritime Connectivity Platform Service Registry API","description":"Maritime Connectivity Platform Service Registry, developed by the MCC MSR WG","termsOfService":"null","contact":{"name":"MCP Consortium","url":"https://mcp.discourse.group/","email":"info@maritimeconnectivity.net"},"license":{"name":"Apache-2.0","url":"http://www.apache.org/licenses/LICENSE-2.0"},"version":"0.0.8"},"servers":[{"url":"https://msr.maritimeconnectivity.net","description":"Generated server url"}],"paths":{"/api/xmls/{id}":{"get":{"tags":["xml-controller"],"operationId":"getXml","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/XmlDto"}}}}}},"put":{"tags":["xml-controller"],"operationId":"updateXml","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/XmlDto"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/XmlDto"}}}}}},"delete":{"tags":["xml-controller"],"operationId":"deleteXml","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK"}}}},"/api/instances/{id}":{"get":{"tags":["instance-controller"],"operationId":"getInstance","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/InstanceDto"}}}}}},"put":{"tags":["instance-controller"],"operationId":"updateInstance","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InstanceDto"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/InstanceDto"}}}}}},"delete":{"tags":["instance-controller"],"operationId":"deleteInstance","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK"}}}},"/api/instances/{id}/status":{"put":{"tags":["instance-controller"],"operationId":"updateInstanceStatus","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"status","in":"query","required":true,"schema":{"type":"string","enum":["PROVISIONAL","RELEASED","DEPRECATED","DELETED"]}}],"responses":{"200":{"description":"OK"}}}},"/api/g1191/v2/updateService/{instanceId}":{"put":{"tags":["update-service-controller"],"operationId":"updateServiceInterface","parameters":[{"name":"instanceId","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/UpdateServiceDto"}}},"required":true},"responses":{"200":{"description":"OK"}}}},"/api/docs/{id}":{"get":{"tags":["doc-controller"],"operationId":"getDoc","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DocDto"}}}}}},"put":{"tags":["doc-controller"],"operationId":"updateDoc","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DocDto"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DocDto"}}}}}},"delete":{"tags":["doc-controller"],"operationId":"deleteDoc","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK"}}}},"/api/xmls":{"get":{"tags":["xml-controller"],"operationId":"getAllXmls","parameters":[{"name":"page","in":"query","description":"Zero-based page index (0..N)","required":false,"schema":{"type":"integer","default":0,"minimum":0}},{"name":"size","in":"query","description":"The size of the page to be returned","required":false,"schema":{"type":"integer","default":20,"minimum":1}},{"name":"sort","in":"query","description":"Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.","required":false,"schema":{"type":"array","items":{"type":"string"}}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/XmlDto"}}}}}}},"post":{"tags":["xml-controller"],"operationId":"createXml","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/XmlDto"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/XmlDto"}}}}}}},"/api/xmls/validate/{schema}":{"post":{"tags":["xml-controller"],"operationId":"validateXmlWithG1128Schema","parameters":[{"name":"schema","in":"path","required":true,"schema":{"type":"string","enum":["INSTANCE"]}}],"requestBody":{"content":{"application/xml":{"schema":{"type":"string"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"object"}}}}}}},"/api/instances":{"get":{"tags":["instance-controller"],"operationId":"getInstances","parameters":[{"name":"page","in":"query","description":"Zero-based page index (0..N)","required":false,"schema":{"type":"integer","default":0,"minimum":0}},{"name":"size","in":"query","description":"The size of the page to be returned","required":false,"schema":{"type":"integer","default":20,"minimum":1}},{"name":"sort","in":"query","description":"Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.","required":false,"schema":{"type":"array","items":{"type":"string"}}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/InstanceDto"}}}}}}},"post":{"tags":["instance-controller"],"operationId":"createInstance","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InstanceDto"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/InstanceDto"}}}}}}},"/api/g1191/v2/uploadResults/{transactionId}":{"post":{"tags":["upload-results-controller"],"operationId":"uploadResults","parameters":[{"name":"transactionId","in":"path","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ServiceInstanceObject"}}}},"required":true},"responses":{"200":{"description":"OK"}}}},"/api/docs":{"get":{"tags":["doc-controller"],"operationId":"getDocs","parameters":[{"name":"page","in":"query","description":"Zero-based page index (0..N)","required":false,"schema":{"type":"integer","default":0,"minimum":0}},{"name":"size","in":"query","description":"The size of the page to be returned","required":false,"schema":{"type":"integer","default":20,"minimum":1}},{"name":"sort","in":"query","description":"Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.","required":false,"schema":{"type":"array","items":{"type":"string"}}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DocDto"}}}}}}},"post":{"tags":["doc-controller"],"operationId":"createDoc","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DocDto"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DocDto"}}}}}}},"/v2/ping":{"get":{"tags":["ping-controller"],"operationId":"ping","responses":{"200":{"description":"OK"}}}},"/api/xmls/schemas/{schema}":{"get":{"tags":["xml-controller"],"operationId":"getG1128Schema","parameters":[{"name":"schema","in":"path","required":true,"schema":{"type":"string","enum":["INSTANCE"]}}],"responses":{"200":{"description":"OK","content":{"application/xml":{"schema":{"type":"string"}}}}}}},"/api/instances/mrn/{mrn}":{"get":{"tags":["instance-controller"],"operationId":"getInstancesByMRN","parameters":[{"name":"mrn","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/InstanceDto"}}}}}}}},"/api/instances/mrn/{mrn}/{version}":{"get":{"tags":["instance-controller"],"operationId":"getInstanceByMRNAndVersion","parameters":[{"name":"mrn","in":"path","required":true,"schema":{"type":"string"}},{"name":"version","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/InstanceDto"}}}}}}}},"components":{"schemas":{"XmlDto":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string"},"comment":{"type":"string"},"content":{"type":"string"},"contentContentType":{"type":"string"}},"required":["content","name"]},"Coordinate":{"type":"object","properties":{"x":{"type":"number","format":"double"},"y":{"type":"number","format":"double"},"z":{"type":"number","format":"double"},"coordinate":{"writeOnly":true},"m":{"type":"number","format":"double"}}},"CoordinateSequence":{"type":"object","properties":{"measures":{"type":"integer","format":"int32"},"dimension":{"type":"integer","format":"int32"}}},"CoordinateSequenceFactory":{},"DocDto":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string"},"comment":{"type":"string"},"mimetype":{"type":"string"},"filecontent":{"type":"string","format":"byte"},"filecontentContentType":{"type":"string"},"instanceId":{"type":"integer","format":"int64"}},"required":["filecontent","mimetype","name"]},"Envelope":{"type":"object","properties":{"diameter":{"type":"number","format":"double"},"height":{"type":"number","format":"double"},"minX":{"type":"number","format":"double"},"maxX":{"type":"number","format":"double"},"minY":{"type":"number","format":"double"},"maxY":{"type":"number","format":"double"},"area":{"type":"number","format":"double"},"width":{"type":"number","format":"double"},"null":{"type":"boolean"}}},"Geometry":{"type":"object","properties":{"envelope":{"$ref":"#/components/schemas/Geometry"},"factory":{"$ref":"#/components/schemas/GeometryFactory"},"userData":{},"geometryType":{"type":"string"},"numGeometries":{"type":"integer","format":"int32"},"precisionModel":{"$ref":"#/components/schemas/PrecisionModel"},"coordinate":{"$ref":"#/components/schemas/Coordinate"},"coordinates":{"type":"array","items":{"$ref":"#/components/schemas/Coordinate"}},"interiorPoint":{"$ref":"#/components/schemas/Point"},"boundaryDimension":{"type":"integer","format":"int32"},"envelopeInternal":{"$ref":"#/components/schemas/Envelope"},"srid":{"type":"integer","format":"int32"},"dimension":{"type":"integer","format":"int32"},"rectangle":{"type":"boolean"},"numPoints":{"type":"integer","format":"int32"},"area":{"type":"number","format":"double"},"centroid":{"$ref":"#/components/schemas/Point"},"boundary":{"$ref":"#/components/schemas/Geometry"},"simple":{"type":"boolean"},"length":{"type":"number","format":"double"},"empty":{"type":"boolean"},"valid":{"type":"boolean"}}},"GeometryFactory":{"type":"object","properties":{"precisionModel":{"$ref":"#/components/schemas/PrecisionModel"},"coordinateSequenceFactory":{"$ref":"#/components/schemas/CoordinateSequenceFactory"},"srid":{"type":"integer","format":"int32"}}},"InstanceDto":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string"},"version":{"type":"string"},"publishedAt":{"type":"string","format":"date-time"},"lastUpdatedAt":{"type":"string","format":"date-time"},"comment":{"type":"string"},"geometry":{"$ref":"#/components/schemas/Geometry"},"geometryContentType":{"type":"string"},"instanceId":{"type":"string"},"keywords":{"type":"array","items":{"type":"string"}},"status":{"type":"string","enum":["PROVISIONAL","RELEASED","DEPRECATED","DELETED"]},"organizationId":{"type":"string"},"unlocode":{"type":"array","items":{"type":"string"}},"endpointUri":{"type":"string"},"statusEndpointUri":{"type":"string"},"mmsi":{"type":"string"},"imo":{"type":"string"},"serviceTypes":{"type":"array","items":{"type":"string"}},"dataProductType":{"type":"array","items":{"type":"string","enum":["OTHER","S57","S101","S102","S104","S111","S122","S123","S124","S125","S126","S127","S128","S129","S131","S201","S210","S211","S212","S401","S402","S411","S412","S413","S414","S421","RTZ","EPC"]}},"instanceAsXml":{"$ref":"#/components/schemas/XmlDto"},"instanceAsDoc":{"$ref":"#/components/schemas/DocDto"},"docIds":{"type":"array","items":{"type":"integer","format":"int64"},"uniqueItems":true},"implementsServiceDesigns":{"type":"object","additionalProperties":{"type":"string"}},"designsServiceSpecifications":{"type":"object","additionalProperties":{"type":"string"}}},"required":["comment","instanceId","name","status","version"]},"Point":{"type":"object","properties":{"envelope":{},"factory":{"$ref":"#/components/schemas/GeometryFactory"},"userData":{},"coordinates":{"type":"array","items":{"$ref":"#/components/schemas/Coordinate"}},"geometryType":{"type":"string"},"coordinateSequence":{"$ref":"#/components/schemas/CoordinateSequence"},"coordinate":{"$ref":"#/components/schemas/Coordinate"},"boundaryDimension":{"type":"integer","format":"int32"},"dimension":{"type":"integer","format":"int32"},"numPoints":{"type":"integer","format":"int32"},"boundary":{},"simple":{"type":"boolean"},"x":{"type":"number","format":"double"},"y":{"type":"number","format":"double"},"empty":{"type":"boolean"},"numGeometries":{"type":"integer","format":"int32"},"precisionModel":{"$ref":"#/components/schemas/PrecisionModel"},"interiorPoint":{},"envelopeInternal":{"$ref":"#/components/schemas/Envelope"},"srid":{"type":"integer","format":"int32"},"rectangle":{"type":"boolean"},"area":{"type":"number","format":"double"},"centroid":{},"length":{"type":"number","format":"double"},"valid":{"type":"boolean"}}},"PrecisionModel":{"type":"object","properties":{"scale":{"type":"number","format":"double"},"maximumSignificantDigits":{"type":"integer","format":"int32"},"offsetX":{"type":"number","format":"double"},"offsetY":{"type":"number","format":"double"},"type":{"$ref":"#/components/schemas/Type"},"floating":{"type":"boolean"}}},"Type":{},"UpdateServiceDto":{"type":"object","properties":{"certificates":{"type":"array","items":{"type":"string"}},"version":{"type":"string"},"endpointUri":{"type":"string"},"apiDoc":{"type":"string"},"statusEndpoint":{"type":"string"}}},"ServiceInstanceObject":{"type":"object","properties":{"instanceId":{"type":"string"},"version":{"type":"string"},"name":{"type":"string"},"status":{"type":"string"},"description":{"type":"string"},"dataProductType":{"type":"array","items":{"type":"string","enum":["OTHER","S-57","S-101","S-102","S-104","S-111","S-122","S-123","S-124","S-125","S-126","S-127","S-128","S-129","S-131","S-201","S-210","S-211","S-212","S-401","S-402","S-411","S-412","S-413","S-414","S-421","RTZ","EPC"]}},"organizationId":{"type":"string"},"endpointUri":{"type":"string"},"endpointType":{"type":"array","items":{"type":"string"}},"keywords":{"type":"array","items":{"type":"string"}},"unlocode":{"type":"array","items":{"type":"string"}},"implementsDesigns":{"type":"array","items":{"type":"string"}},"apiDoc":{"type":"string"},"coverageArea":{"type":"array","items":{"type":"string"}},"imo":{"type":"string"},"mmsi":{"type":"string"},"certificates":{"type":"array","items":{"type":"string"}},"sourceMSRs":{"type":"array","items":{"type":"string"}},"unsupportedParams":{"type":"array","items":{"type":"string"}}}}}}}